<?php
/*
Plugin Name: WP Cleaner
Plugin URI: http://www.jiangmiao.org/blog/c/wpcleaner
Description: 删除不需要的文章，节省空间，提高速度。delete posts which don't need any more,keep database clean and fast.
Author:  JiangMiao
Version: 1.0.3
Author URI: http://www.jiangmiao.org/blog
 */

add_action('admin_menu', 'revisionCleanerMenuu');

function revisionCleanerMenuu() {
	add_options_page('WPCleaner Options', 'WP Cleaner', 8, __FILE__, 'revisionCleanerOptions');
}

function revisionCleanerDo($type,$status,$name) {
	global $wpdb;
	if($status=='publish')
	{
		return "出现问题，您试图在删除已发页的贴子，放弃操作。:(";
	}
	$where='';
	if($type=='all'&&$status=='all')
	{
		$where = " and (post_type='".$wpdb->escape('revision')."' or post_status='".$wpdb->escape('draft')."' or post_status='".$wpdb->escape('auto-draft')."')";
	}
	else
	{
		if($type!='revision' and $status!='draft' and $status!='auto-draft')
		{
			return "该插件只能改变修订版或草稿。 :(";
		}

		if($type!='')
		{
			$where .= " and post_type='".$wpdb->escape($type)."'";
		}
		if($status!='')
		{
			$where .= " and post_status='".$wpdb->escape($status)."'";
		}
	}
	$sqlcmd=<<<EOT
delete from $wpdb->posts where 1 {$where}
EOT;
	$wpdb->query($sqlcmd);
	$wpdb->query("delete from {$wpdb->term_relationships} WHERE term_taxonomy_id=1 and object_id not in (select id from wp_posts)");
	return "成功{$name}";
}

function revisionCleanerOptions() {
	global $wpdb;
	global $_POST;
	echo <<<EOT
<script type="text/javascript">
function revisionCleanerDo(type,status,ob)
{
	if(!confirm("确定\""+ob.value+"\"?"))
		return;
	ob.form.post_type.value=type;
	ob.form.post_status.value=status;
	ob.form.post_name.value=ob.value;
	ob.form.submit();
	return;
}
</script>
<div class="wrap">
<div id="icon-options-general" class="icon32"><br /></div>
<h2>WP Cleaner</h2>
EOT;
	if($_POST['action'])
	{
		$rt=revisionCleanerDo(trim($_POST['post_type']).'',trim($_POST['post_status']).'',trim($_POST['post_name']).'');
		echo <<<EOT
<div id="message" class="updated fade"><p>{$rt}</p></div>
EOT;
	}
	$result=$wpdb->get_results("select post_type,post_status,count(*) as c from $wpdb->posts group by post_type,post_status order by post_status,post_type");
	echo <<<EOT
<form method="post" action="{$_SERVER['REQUEST_URI']}">
<h3>提示</h3><p>
本操作将删除所有冗余修订版，
该操作是不可逆的，
请作好<b>备份</b>工作，谢谢:)<br/>
本插件有保护机制，无论怎么操作都无法影响已发布的贴子，请放心使用^^
</p>
<h3>文章统计信息</h3>
<form>
<table class="form-table" style="width:auto">
<tr><th style="width:6em">贴子类型</th><th style="width:6em">贴子状态</th><th style="width:6em">贴子数量</th></tr>
EOT;

	$postTypes=array("page"=>"页面","post"=>"文章","revision"=>"修订版","attachment"=>"附件");
	$postStatuses=array("draft"=>"草稿","publish"=>"已发布","inherit"=>"继承","pending"=>"等待复审",'auto-draft'=>'自动保存','private'=>'私有');
	foreach($result as $row)
	{
		$style="";
		$disabled=false;
		if($row->post_status!="draft"&&$row->post_type!='revision' && $row->post_status!="auto-draft")
		{
			$disabled=true;
		}
		if($disabled)
		{
			$style='style="color:#ccc"';
		}
		$postType=$postTypes[$row->post_type];
		$postStatus=$postStatuses[$row->post_status];
		if(!$postType)$postType=$row->post_type;
		if(!$postStatus)$postStatus=$row->post_status;
		echo <<<EOT
		<tr $style><td>{$postType}</td><td>{$postStatus}</td><td>{$row->c}</td>
EOT;
		if(!$disabled)
		{
			echo <<<EOT
<td>
<input class="button-primary" type="button" value="删除所有 {$postType}-{$postStatus}({$row->c})" style="font-size:12px !important;font-weight:normal" onclick="revisionCleanerDo('{$row->post_type}','{$row->post_status}',this)"/>
</td>
EOT;
		}
	}

	echo <<<EOT
</table>
<div>
EOT;
	$sqlcmd="select count(*) as c from {$wpdb->term_relationships} WHERE term_taxonomy_id=1 and object_id not in (select id from {$wpdb->posts})";
	$row=$wpdb->get_row($sqlcmd);
	$count=$row->c;
	if($count>0)
	{
		$count="<span style=\"color:red\">{$count}</span>";
	}
	echo <<<EOT
<div>{$count}条冗余修订本关联</div>
<input type="hidden" name="post_type" value=""/>
<input type="hidden" name="post_status" value=""/>
<input type="hidden" name="post_name" value=""/>
<input type="hidden" name="action" value="update"/>
<input class="button-primary" type="button" value="删除所有修订版" style="font-size:12px !important;font-weight:normal" onclick="revisionCleanerDo('revision','',this)"/>
<input class="button-primary" type="button" value="删除所有草稿" style="font-size:12px !important;font-weight:normal" onclick="revisionCleanerDo('','draft',this)"/>
<input class="button-primary" type="button" value="删除所有修订版和草稿" style="font-size:12px !important;font-weight:normal" onclick="revisionCleanerDo('all','all',this)"/>
</div>
</form>
</div>
EOT;
}
